#include "game/game.as";
//#include "core/Entities/Actor.as";

Control@ control;
DirectionalLight@ dirlight;
//EnvironmentLight@ light;
Quaternion Yaw;
Quaternion Pitch;

Scene@ s;
Scene@ interfaceScene;
Scene@ SKYBOX_SCENE;
Camera@ MAIN_CAM;
Camera@ MAIN_CAM2;
Camera@ INTERFACE_CAM;
Camera@ SKYBOX_CAM;

Window@ MAIN_WINDOW;
Window@ SKYBOX_WINDOW;
ResourcePool@ pool;
Object@ sphere;
ObjectFactory@ objectFactory;
Timer@ t;
float tNr = 0;
Viewport@ v1;
Viewport@ v2;

String ASSETS_LOCATION = "../../Assets/";
void main(Control@ _control) {
	setDefaultMutable(pMS_MUTABLE);
	
	@pool = ResourcePool();
	@control = _control;
	@objectFactory = ObjectFactory(pool);
	Renderer@ renderer;
	@renderer = OpenGL4Renderer();
	control.setRenderer(renderer);
	
	//@stepHandler = control.createDelegate("void doStep(pUInt)");	
	// @t = control.createTimer(10, true);
	// @moveTest = control.createDelegate("void doMove()", t);
	// t.start();
	@MAIN_WINDOW = renderer.createWindow(1920, 1080, true);
	MAIN_WINDOW.open();
	//MAIN_WINDOW.GrabInput = true;
	OctreePartition p1;
	OctreePartition p2;
	OctreePartition p3;
	@s = Scene(p1);
	@SKYBOX_SCENE = Scene(p3);
	@interfaceScene = Scene(p2);
	
	@MAIN_CAM = Camera(60, pFloat(MAIN_WINDOW.width)/MAIN_WINDOW.height, 0.1f, 100.0f);
	//@MAIN_CAM2 = Camera(60, pFloat(MAIN_WINDOW.width)/MAIN_WINDOW.height, 0.1f, 100.0f);
	@SKYBOX_CAM = Camera(60, pFloat(MAIN_WINDOW.width)/MAIN_WINDOW.height, 0.1f, 1000.0f);
	//@c2 = Camera(pFloat(-MAIN_WINDOW.width)/2, pFloat(MAIN_WINDOW.width)/2, pFloat(-MAIN_WINDOW.height)/2, pFloat(MAIN_WINDOW.height)/2, 0.1f, 1000.0f);
	@INTERFACE_CAM = Camera(-512, 512, -287,287, 0.1f, 1000.0f);

	//Viewport @v1 = Viewport(0, 0, MAIN_WINDOW.width / 2, MAIN_WINDOW.height / 2);
	@v1 = Viewport(0, 0, MAIN_WINDOW.width, MAIN_WINDOW.height);
	@v2 = Viewport(0, 0, MAIN_WINDOW.width, MAIN_WINDOW.height);
	
	v1.addCamera(1, MAIN_CAM);
	//v1.addCamera(1, MAIN_CAM2);
	v1.addCamera(0, SKYBOX_CAM);
	v1.addCamera(2, INTERFACE_CAM);
	//v1.enableClear(Color(BG_COLOR));
	v1.enableClear(Color(100, 100, 100, 255));
	v2.enableClear(Color(100, 100, 100, 255));
	
	MAIN_WINDOW.addViewport(v1);
	//sMAIN_WINDOW.addViewport(v2);
	
	s.add(MAIN_CAM);
	//@MAIN_CAM2.sceneRef = s;
	SKYBOX_SCENE.add(SKYBOX_CAM);
	interfaceScene.add(INTERFACE_CAM);
	
	//MAIN_CAM2.disable();
	MAIN_CAM.enable();
	INTERFACE_CAM.enable();
	SKYBOX_CAM.enable();
		
	control.addScene(s);	
	control.addScene(interfaceScene);	
	control.addScene(SKYBOX_SCENE);	
	
	init();
}

